
//*****************************************************************************
// Steffen from "Mikrocontrollerspielwiese" wrote this file for an easier
// using of ADC0 on atmega8. The program takes the analogue value
// of ADC0 and uses average values to minimize noise errors.
// 
// You find it at http://www.mikrocontrollerspielwiese.de
//
// license: GPL (http://www.gnu.org/licenses/gpl.txt)
//
// have fun!
//*****************************************************************************


int MESSWERT (int kanal){

  	int i,j,z;// z  
	z= 300;
	i=z, j=z;
  	
	
	long int analogwert=0, analogwert1=0, analogwert2=0 ;
	
	while(j){
  		
		while(i){
			ADCSRA=0x80; 		// ADC eingeschaltet, kein Prescale 
			ADMUX=kanal;  			// ADC Ref auf Avcc, ADC0 gewaehlt, normale Formatierung
			ADCSRA |=_BV(ADSC); 	// single conversion mode ein
			while (ADCSRA & (1<<ADSC)) {;}	// auf Abschluss der Konvertierung warten 
			analogwert+=ADCW;
			i--;
		}
		
		analogwert1 = analogwert/z;
		analogwert2 += analogwert1;
		j--;
	}
	
	analogwert=(analogwert2/z);

	return (analogwert);
}


